

var canvas = document.getElementById("myCanvas");
var ctx = canvas.getContext("2d");

var topoTxt=
`
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
X                                             X                        X
X                                             X                        X
X                                             X                        X
X                                             X                        X
X      X                     X                X                        X
X      X                     X                X              X         X
X      X                     X                               X         X
X      XXXXXXXX              X                               X         X
X             X              X                               X         X
X             X              X                               X         X
X             XXXXXXXXXXXXXXXXXXXXXXXXXXXXX                  X         X
X             X                           X                  X         X
X             X                           X                  X         X
XXXXXXXXXXXXXXX                           X                  X         X
X     X                                                      X         X
X     X                                                 XXXXXX         X
X     X                                                 X              X
X     X                                                 X              X
X     X                                                 X              X
X     X             XXXXXXXXXXXXXXXXXXXX                X              X
X     X                  X             X                X              X
X     X                  X             X                X              X
X     X                  X             X                X              X
X                        X             X                X              X
X                        X             X                X              X
X                        X             X                X              X
X                        X             XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXX                X             X                               X
XXXXXXXXX                              X                               X
XXXXXXXXX                                                              X
XXXXXXXXX                                                       XXXXXXXX
XXXXXXXXX                                                       XXXXXXXX
XXXXXXXXXX                                                     *XXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
`;



var color = 2;
var w = 26;
var h = 10;
var n = 4;
var nmax = n;
var ctr = 0;
var total = 0;

var heads = [0,0];

var tmp = [];
var ctrW = 0;
var ctrH = 0;



for(var i=0;i<topoTxt.length;i++)
{
	switch(topoTxt.charAt(i))
	{
		case "X": tmp.push(1);break;
		case " ": 
			total++;
			tmp.push(0);
			break;
		case "*": 
			tmp.push(2);
			heads[1] = tmp.length-1;
			heads[0] = heads[1];
			break;
		case "\n": 
			w = ctrW;
			ctrW = 0;
			ctrH++;
		default: continue;
	}
	ctrW++;
}

h = ctrH-1;
var balance = Math.floor(total/nmax);

var topo = new Int8Array(tmp);

var dirsx = new Int8Array([-1,0,1,0]);
var dirsy = new Int8Array([0,-1,0,1]);



function init()
{
	
	clearInterval(interval);
	interval = null;
	
	color = 2;
	w = 26;
	h = 10;
	n = 4;
	nmax = n;
	ctr = 0;
	total = 0;

	heads = [0,0];

	tmp = [];
	ctrW = 0;
	ctrH = 0;

	for(var i=0;i<topoTxt.length;i++)
	{
		switch(topoTxt.charAt(i))
		{
			case "X": tmp.push(1);break;
			case " ": 
				total++;
				tmp.push(0);
				break;
			case "*": 
				tmp.push(2);
				heads[1] = tmp.length-1;
				heads[0] = heads[1];
				break;
			case "\n": 
				w = ctrW;
				ctrW = 0;
				ctrH++;
			default: continue;
		}
		ctrW++;
	}

	h = ctrH-1;
	balance = Math.floor(total/nmax);

	topo = new Int8Array(tmp);

	dirsx = new Int8Array([-1,0,1,0]);
	dirsy = new Int8Array([0,-1,0,1]);
	
	drawCanvas();
}






var scale = 10;

function drawCanvas() 
{
	for(var j=0;j<h;j++)
	{
		for(var i=0;i<w;i++)
		{
			switch(topo[j*w+i])
			{
				case 0: ctx.fillStyle = 'rgb(70, 70, 70)'; break;
				case 1: ctx.fillStyle = 'rgba(0, 0, 0, 0)'; break;
				case 2: ctx.fillStyle = 'rgb(0, 0, 200)'; break;
				case 3: ctx.fillStyle = 'rgb(200, 0, 0)'; break;
				case 4: ctx.fillStyle = 'rgb(0, 200, 0)'; break;
				case 5: ctx.fillStyle = 'rgb(200, 0, 200)'; break;
				case 6: ctx.fillStyle = 'rgb(200, 200, 0)'; break;
				case 7: ctx.fillStyle = 'rgb(0, 200, 200)'; break;
			}
			
			ctx.fillRect(i*scale, j*scale, scale, scale);
		}
	}
}

function drawAt(pos)
{
	i = pos %w;
	j = (pos-i)/w;
	ctx.fillStyle = 'rgb(200, 0, 0)';
	ctx.fillRect(i*scale, j*scale, scale, scale);
}



function checkForReduction(pos,dx,dy,side,type)
{
	
	var dx90 = (1-Math.abs(dx))*side;
	var dy90 = (1-Math.abs(dy))*side;
	var ends = [0,0];
	var support = false;
	var noWall = 0;
	var notWide = 0;
	var wideEnough = false;
	
	//Start test:
	if(topo[pos] > 0) //If cannot start:
	{	
		console.log("Start test failed, cannot start!");
		console.log("pos=",pos);
		return null;
	}
	
	var dir = -1;
	
	for(var i=0;i<2;i++)
	{
		
		var end = pos;
		var preEnd = end;
		
		
		outerloop:
		while(1)
		{	
			//Test wall:
			if(topo[end] > 0) //If there is a wall:
			{
				console.log("Wall found!");
				console.log("end=",end);
				console.log("preEnd=",preEnd);
				ends[i] = preEnd;
				break;
			}
			
			//Test support:
			if(topo[end - (w*dy90 + dx90)] <= 0) //If no support:
			{
				if(type == 0)		//Primary reduction:
				{
					console.log("No support in primary reduction!!!");
					console.log("end=",end);
					console.log("preEnd=",preEnd);
					return null;
				}
				else				//Secondary reduction:
				{
					console.log("No support in secondary reduction...");
					console.log("end=",end);
					console.log("preEnd=",preEnd);
					
					if(!support)	//Must have support!
					{
						console.log("No support at all, MUST HAVE SUPPORT!!!");
						return null;
					}
					else
					{
						if(noWall > 0)
						{
							console.log("TWO WALLS!!");
							ends[i] = pos;
						}
						else
						{
							console.log("One wall for now...");
							ends[i] = preEnd;
							if(preEnd == pos)
								break;
						}
						noWall++;
						break;
					}
				}
			}
			
			support = true;
			
			
			//Test line wideness:
			for(var j=0;j<n;j++)
			{
				if(topo[end + j*(w*dy90 + dx90)] > 0) //Line not wide enough!
				{
					console.log("Line not wide enough in this end...");
					
					if(type == 0)
					{
						console.log("...AND WE ARE IN A PRIMARY REDUCTION, ABORT, ABORT!!!");
						return null;
					}
					else
					{
						if(notWide<=0)
						{
							console.log("...But we are in secondary reduction, so, maybe, we can continue, do you think so ?");
							ends[i] = pos;
							notWide++;
							break outerloop;
						}
						else
						{
							console.log("In No direction corridors are wide enough. I GIVE UP!!");
							return null;
						}
						
					}
					
				}
			}
			
			console.log("WIDE ENOUGH!!");
			wideEnough = true;
			
			//Next pos on the line:
			preEnd = end;
			end += (dx+w*dy)*dir;
		}
		
		dir += 2;
	}
	
	//~ //TODO: DO IT PROPERLY!!
	//~ if(ends[0] == ends[1])
		//~ return null;
	
	if(!wideEnough) //If after 2 steps, there is still no corridors wide enough, ABORT!!
	{
		console.log("CORRIDORS ARE NOT WIDE ENOUGH!!!!");
		return null;
	}
	
	if(type == 1)
	{
		console.log("SECONDARY REDUCTION, CHECK FOR TRUE WALLS!!!");
		console.log("end1=",ends[0]," end2=",ends[1]);
		
		var pos = ends[0];
		var trueWalls = false;
		do
		{
			if(topo[pos - (w*dy90 + dx90)] < color)
			{
				console.log("TRUE WALL AT:",pos - (w*dy90 + dx90));
				trueWalls = true;
				break;
			}
			
			if(pos == ends[1])
				break;
				
			pos += w*dy+dx;
			
		}while(1);
		
		if(trueWalls)
		{
			console.log("WALLS ARE TRUE, OK!!");
		}
		else
		{
			console.log("WALLS ARE FAKE!! REFUSED REDUCTION!!!");
			return null;
		}
		
	}
	
	console.log("REDUCTION FOUND!! ","end1=",ends[0]," end2=",ends[1]);
	return ends;
	
}



function checkForAllReductions(heads)
{
	var offsets = [-1,1,-w,w];
	
	//For each type:
	for(var t=0;t<2;t++)
	{
		//For each head:
		for(var i=0;i<2;i++)
		{
			var h = heads[i];	
					
			//For each offsetPosition:
			for(var o=0;o<4;o++)
			{
				var pos = h + offsets[o];
					
				//For each direction:
				for(var j=0;j<2;j++)
				{
					var dx = j;
					var dy = 1-j;
					
					//For each side:
					for(var s=-1;s<=1;s+=2)
					{
						console.log("CHECK REDUCTION:pos=",pos," dx=",dx," dy=",dy," s=",s," t=",t);
						var res = checkForReduction(pos,dx,dy,s,t);
						if(res != null)
							return res;
					}
				}
				
			}
		}	
	}
}


function reduce(ends)
{
	

	
	var a = ends[0];
	var b = ends[1];
	
	if(a == b)
	{
		topo[a] = color;
		ctr++;
		
		if(ctr > balance)
		{
			ctr = 0;
			color++;
			n--;
		}
		
		return;
	}
	
	var ax = a%w;
	var ay = (a-ax)/w;
	
	var bx = b%w;
	var by = (b-bx)/w;
	
	var dx = bx-ax;
	var dy = by-ay;
	
	var d = Math.abs(dx + dy);
	
	dx /= d;
	dy /= d;
	
	console.log("d=",d);
	console.log("dx=",dx);
	console.log("dy=",dy);
	
	//Colorize the line:
	for(var i=0;i<=d;i++)
	{
		topo[a+i*(w*(dy)+dx)] = color;
		ctr++;
		
		if(ctr > balance)
		{
			ctr = 0;
			color++;
			n--;
		}
		
	}
}


function step()
{	
	if(n <= 1)
	{
		for(var i=0;i<topo.length;i++)
		{
			if(topo[i] == 0)
				topo[i] = color;
		}
		drawCanvas();
		return false;
	}
	else
	{
	
		var res = checkForAllReductions(heads);
		if(res == null)
			return null;
		heads = res;
		reduce(heads);
	}
	
	drawCanvas();
	//printTopo();
	return true;
}

function printTopo()
{	
	var text="";
	for(var j=0;j<h;j++)
	{
		for(var i=0;i<w;i++)
			text+= topo[i+w*j];
		text+="<br>";
	}
	
	document.body.innerHTML= text;
}


var interval = null;

function run()
{
	if(interval != null)
	{
		clearInterval(interval);
		interval = null;
	}
	else
	{
		interval = setInterval(step,300);
	}
}

function runFast()
{
	if(interval != null)
	{
		clearInterval(interval);
		interval = null;
	}
	else
	{
		interval = setInterval(step,50);
	}
}

function stop()
{

	clearInterval(interval);
	interval = null;

}

function getCoords(pos)
{
	console.log("y=",Math.floor(pos/w)," x=",pos%w);
}


drawCanvas();
